#ifndef __HOGWASH_CNTL_H
#define __HOGWASH_CNTL_H

#include "../hogwash-0.2/control-common.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define MAX_TARGETS				16
#define MAX_PACKETS_IN_FLIGHT	64

typedef struct target_record{
	struct in_addr	ip;
	TwoFishKey		key;
	char			name[512];
} TargetRecord;

typedef struct packet_state{
	char			InUse;
	unsigned int 	PacketID;
	unsigned char	RetriesLeft;
	char			RawData[65536];
	int				RawSize;
	int (*pResponseCallback) (int Success, char* Data, int Datalen, void* user);
	TargetRecord*	Target;
	unsigned long	LastTime;
	void*			user;
}PacketState;

struct panel_vars{
	int					sock_fd;
	struct sockaddr_in	sock_addr;	
	TargetRecord		targets[MAX_TARGETS];
	unsigned char		num_targets;
};

struct panel_vars pv;
struct packet_state	ps[MAX_PACKETS_IN_FLIGHT];

int chogwash_init(char* config_file);
int chogwash_ping(struct in_addr ip, int wait_sec);
int	chogwash_get_buff_chunk(
	struct in_addr ip, 
	int wait_sec, 
	unsigned int BuffID, 
	unsigned int Offset, 
	unsigned int Len, 
	ControlPacketBuffReply* p);
int	chogwash_get_buff(
	struct 			in_addr ip, 
	int				wait_sec,
	unsigned int 	BuffID, 
	char* 			OutBuff,
	unsigned int	OutBuffLen);	
int	chogwash_set_buff(
	struct 			in_addr ip, 
	int				wait_sec,
	unsigned int 	BuffID, 
	char* 			OutBuff,
	unsigned int	OutBuffLen);		
int chogwash_get_buff_stat(
	struct in_addr	ip,
	int				wait_sec,
	unsigned int	BuffID,
	ControlPacketStatReply*	stat);
int chogwash_destroy();


#endif
